LTC = {};

---------
function LTC:OnLoad()
---------
	SLASH_LOST_TREASURE_CHECK1 = "/ltc";
	SlashCmdList["LOST_TREASURE_CHECK"] = function(msg) LTC:HandleSlashCommand(msg) end

	LTCFrame:RegisterEvent("PLAYER_LOGIN")
	LTCFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	LTCFrame:RegisterEvent("ADDON_LOADED")
end

---------
function LTC:OnEvent(self, event, ...)
---------
	local arg1, arg2, arg3, arg4 = ...
	if event == "ADDON_LOADED" and arg1 == "Lost Treasure Check" then
		LTCFrame:UnregisterEvent("ADDON_LOADED");
	elseif event == "PLAYER_LOGIN" then
		LTCFrame:UnregisterEvent("PLAYER_LOGIN");
		LTC:LoadData();
		LTC:Announce();		
	elseif event == "PLAYER_ENTERING_WORLD" then
		LTCFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
	end
end

---------
function LTC:LoadData()

	LTC_flags = {
		-- The Jade Forest
		[806] = {
			[31402] = { ["name"] = "Ancient Jinyu Staff", 						["itemID"] = 86196 },
			[31399] = { ["name"] = "Ancient Pandaren Mining Pick", 				["itemID"] = 85777 },
			[31400] = { ["name"] = "Ancient Pandaren Tea Pot", 					["itemID"] = 85780 },
			[31403] = { ["name"] = "Hammer of Ten Thunders", 					["itemID"] = 86198 },
			[31307] = { ["name"] = "Jade Infused Blade", 						["itemID"] = 86199 },
			[31401] = { ["name"] = "Lucky Pandaren Coin",						["itemID"] = 85781 },
			[31865] = { ["name"] = "Offering of Rememberance",					["itemID"] = nil   },
			[31404] = { ["name"] = "Pandaren Ritual Stone",						["itemID"] = 86216 },
			[31396] = { ["name"] = "Ship's Locker",								["itemID"] = nil   },
			[31866] = { ["name"] = "Stash of Gems",								["itemID"] = nil   },
			[31397] = { ["name"] = "Wodin's Mantid Shanker", 					["itemID"] = 85776 }
		},

		-- Valley of the Four Winds
		[807] = {
			[31284] = { ["name"] = "Ancient Pandaren Fishing Charm", 			["itemID"] = 85973 },
			[31292] = { ["name"] = "Ancient Pandaren Woodcutter",				["itemID"] = 86079 },
			[31869] = { ["name"] = "Boat-Building Instructions",				["itemID"] = nil   },
			[31406] = { ["name"] = "Cache of Pilfered Goods",					["itemID"] = nil   },
			[31407] = { ["name"] = "Staff of the Hidden Master",				["itemID"] = 86218 },
			[31405] = { ["name"] = "Virmen Treasure Cache",						["itemID"] = nil   }
		},

		-- Krasarang Wilds
		[857] = {
			[31410] = { ["name"] = "Equipment Locker",							["itemID"] = nil   },
			[31409] = { ["name"] = "Pandaren Fishing Spear",					["itemID"] = 86124 },
			[31411] = { ["name"] = "Recipe: Banana Infused Rum",				["itemID"] = 87266 },
			[31408] = { ["name"] = "Saurok Stone Tablet",						["itemID"] = 86220 },
			[31863] = { ["name"] = "Stack of Papers",							["itemID"] = 87798 }
		},

		-- The Veiled Stair
		[873] = {
			[31867] = { ["name"] = "Forgotten Lockbox",							["itemID"] = nil   },
			[31428] = { ["name"] = "Hammer of Folly",							["itemID"] = 86473 }
		},

		-- Kun-Lai Summit
		[809] = {
			[31420] = { ["name"] = "Ancient Mogu Tablet",						["itemID"] = 86471 },
			[31414] = { ["name"] = "Hozen Treasure Cache",						["itemID"] = nil   },
			[31413] = { ["name"] = "Hozen Warrior Spear",						["itemID"] = 86394 },
			[31304] = { ["name"] = "Kafa Press",								["itemID"] = 86125 },
			[31418] = { ["name"] = "Lost Adventurer's Belongings",				["itemID"] = nil   },
			[31868] = { ["name"] = "Mo-Mo's Treasure Chest",					["itemID"] = nil   },
			[31419] = { ["name"] = "Rikktik's Tick Remover",					["itemID"] = 86430 },
			[31412] = { ["name"] = "Sprite's Cloth Chest",						["itemID"] = nil   },
			[31416] = { ["name"] = "Statue of Xuen",							["itemID"] = 86422 },
			[31415] = { ["name"] = "Stolen Sprite Treasure",					["itemID"] = nil   },
			[31421] = { ["name"] = "Sturdy Yaungol Spear",						["itemID"] = 88723 },
			[31417] = { ["name"] = "Tablet of Ren Yun",							["itemID"] = 86393 },
			[31422] = { ["name"] = "Terracotta Head", 							["itemID"] = 86427 }
		},

		-- Townlong Steppes
		[810] = {
			[31427] = { ["name"] = "Abandoned Crate of Goods",					["itemID"] = nil   },
			[31426] = { ["name"] = "Amber Encased Moth",						["itemID"] = 86472 },
			[31423] = { ["name"] = "Fragment of Dread",							["itemID"] = 86516 },
			[31424] = { ["name"] = "Hardened Sap of Kri'vess",					["itemID"] = 86517 },
			[31425] = { ["name"] = "Yaungol Fire Carrier",						["itemID"] = 86518 },
		},

		-- Dread Wastes
		[858] = {
			[31438] = { ["name"] = "Blade of the Poisoned Mind",				["itemID"] = 86527 },
			[31433] = { ["name"] = "Blade of the Prime",						["itemID"] = 86522 },
			[31436] = { ["name"] = "Bloodsoaked Chitin Fragment",				["itemID"] = 86525 },
			[31864] = { ["name"] = "Chest of Supplies",							["itemID"] = nil   },
			[31435] = { ["name"] = "Dissector's Staff of Mutation",				["itemID"] = 86524 },
			[31431] = { ["name"] = "Lucid Amulet of the Agile Mind",			["itemID"] = 86521 },
			[31430] = { ["name"] = "Malik's Stalwart Spear",					["itemID"] = 86520 },
			[31432] = { ["name"] = "Manipulator's Talisman",					["itemID"] = 86529 },
			[31437] = { ["name"] = "Swarmkeeper's Medallion",					["itemID"] = 86526 },
			[31434] = { ["name"] = "Swarming Cleaver of Ka'roz",				["itemID"] = 86523 },
			[31429] = { ["name"] = "Wind-Reaver's Dagger of Quick Strikes",		["itemID"] = 86519 }
		}
	}
	
	LTC_items = {};

	LTC_location_order = {806,807,857,873,809,810,858};

	LTC_total = LTC:CountFlags();
end

---------
function LTC:Announce()
---------
	DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."LostTreasureCheck |rloaded "..GREEN_FONT_COLOR_CODE..LTC_total.."|r items.");
end

---------
function LTC:HandleSlashCommand(cmd)
---------
	if string.lower(cmd) == "all" then
		LTC:CheckFlags(nil, true);
	elseif string.lower(cmd) == "zone" then
		LTC:CheckFlags(LTC:GetLocationID(), false)
	elseif string.lower(cmd) == "zone all" then
		LTC:CheckFlags(LTC:GetLocationID(), true)
	else
		LTC:CheckFlags(nil, false);
	end
end

---------
function LTC:GetLocationID()
---------
	SetMapToCurrentZone();
	return GetCurrentMapAreaID();
end

---------
function LTC:CountFlags()
---------
	local count = 0;
	for loc,ids in pairs(LTC_flags)
	do
		for _ in pairs(LTC_flags[loc])
		do
			count = count + 1;
		end
	end
	return count;
end

---------
function LTC:CheckFlags(locationID, showCompleted)
---------
	LTC:PrintHeader();

	local completed = 0;

	if not locationID then
		-- No location specified, show all locations
		if LTC_location_order then
			-- Retrieve locations
			for index, loc in pairs(LTC_location_order)
			do
				completed = completed + LTC:CheckLocationFlags(loc, showCompleted);
				LTC:PrintLocationFooter();
			end
		LTC:PrintFooter(completed);
		end
	else
		-- Show only the specified location
		completed = LTC:CheckLocationFlags(locationID, showCompleted);
		LTC:PrintSeparatorLine();
	end
end

---------
function LTC:CheckLocationFlags(locationID, showCompleted)
---------
	local completed = 0;
	local total = 0;
	local isCompleted = {};
	local orderedFlags = {};

	if locationID then
		-- Retrieve quest flag IDs by location
		if(LTC_flags[locationID]) then
			-- Check if each flag is completed and increment counts
			for questID,info in pairs(LTC_flags[locationID])
			do
				total = total + 1;
				if IsQuestFlaggedCompleted(questID) == 1 then
					isCompleted[questID] = true;
					completed = completed + 1;
				else
					isCompleted[questID] = false;
				end;
				-- Insert flag IDs into a list for sorting later
				table.insert(orderedFlags, questID);
			end

			-- Sort flag IDs to maintain order
			table.sort(orderedFlags);

			LTC:PrintLocationHeader(locationID, total, completed);

			-- Only print this location's header if we have flags to display
			if showCompleted or (total - completed) > 0 then
				LTC:PrintLocationFlags(locationID, orderedFlags, isCompleted, showCompleted);
			end
		else
			LTC:PrintLocationHeader(locationID, 0, 0);
		end
	end

	return completed;
end

---------
function LTC:CountCompleted(locationID)
---------

end


---------
function LTC:PrintHeader()
---------
	--LTC:PrintSeparatorLine();
	DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."Lost Treasure Check: |r");
	LTC:PrintSeparatorLine();
end

---------
function LTC:PrintFooter(completed)
---------
	--LTC:PrintSeparatorLine();
	DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."Total Treasures Found: |r"..completed.."/"..LTC_total);
	LTC:PrintSeparatorLine();
end

---------
function LTC:PrintSeparatorLine()
---------
	DEFAULT_CHAT_FRAME:AddMessage("---------------------------|r");
	end

---------
function LTC:PrintLocationHeader(locationID, total, completed)
---------
	DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE..GetMapNameByID(locationID).."|r ("..(total - completed).." of "..total..RED_FONT_COLOR_CODE.." missing|r): ");
end

---------
function LTC:PrintLocationFlags(locationID, flags, isCompleted, showCompleted)
---------
	for index,questID in pairs(flags)
	do
		local link;
		local c = isCompleted[questID];
		local itemID = LTC:GetItemID(locationID, questID);

		if itemID ~= nil then
			link = LTC:GetItemLink(itemID);
		end

		if not link then
			link = LTC:GetFlagName(locationID, questID);
		end

		LTC:PrintFlagInfo(link, c, showCompleted)
	end
end

---------
function LTC:PrintLocationFooter()
---------
	DEFAULT_CHAT_FRAME:AddMessage("\n");
end

---------
function LTC:PrintFlagInfo(link, isCompleted, showCompleted)
---------
	if not isCompleted then
		DEFAULT_CHAT_FRAME:AddMessage(" - "..link..": "..RED_FONT_COLOR_CODE.."Missing |r");
	else
		if showCompleted then
			DEFAULT_CHAT_FRAME:AddMessage(" - "..link..": "..GREEN_FONT_COLOR_CODE.."Found |r");
		end
	end
end
---------
function LTC:GetItemID(locationID, questID)
---------
	return LTC_flags[locationID][questID]["itemID"];
end

---------
function LTC:GetFlagName(locationID, questID)
---------
	return LTC_flags[locationID][questID]["name"];
end

---------
function LTC:GetItemLink(itemID)
---------
	if itemID then
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemID);
		return itemLink;	
	else
		return nil;
	end
end